/**
* @brief
数据库助手类

* @version
V 1.0.0

* @author

* @date
创建时间:  2018-04-19\n

* @note
2018-04-19  创建类。\n

* @warning

* @bug

*/

#pragma once

#include <mysql.h>

namespace YADB
{
	class CDBHelper
	{
	public:
		CDBHelper();
		~CDBHelper();
		/**
	    * @brief
	    把时间字符串转成MYSQL_TIME的函数。

	    * @param  [in] char* szdtString  时间字符串\n
	    * @param  [out] MYSQL_TIME & value  转换好的MYSQL_TIME类型的值\n

	    * @return 无\n

	    * @note

	    * @warning

	    * @bug

	    */
		void String2DateTime( const char* szString, MYSQL_TIME & value );
		/**
	    * @brief
	    把MYSQL_TIME转成时间字符串转成函数。

	    * @param  [in] MYSQL_TIME & value  要转换的MYSQL_TIME类型的值\n
	    * @param  [out] char* szdtString  时间字符串\n

	    * @return 无\n

	    * @note

	    * @warning

	    * @bug

	    */
		void DateTime2String( const MYSQL_TIME & value, char* szString, int Length );
		/**
		* @brief
		把MYSQL_TIME初始化函数。

		* @param  [out] MYSQL_TIME & value  要初始化的MYSQL_TIME值\n

		* @return 无\n

		* @note

		* @warning

		* @bug

		*/
		void InitMySQLTime( MYSQL_TIME & value );
	};

}
