/*
 * define communication protocol between hardware device and software.
 * there are three parts:
 * 1.tof
 * 2.tdoa
 * 3.other
 *
 * */
#ifndef protocol_hpp
#define protocol_hpp

// 1.tof
#define CHAR_LOCATEDATA_TOF_EXTEND          0x843b	// TOF实时定位数据，请求、应答
#define CHAR_LOCATEDATASMALL_TOF_EXTEND     0x753b	// TOF实时小分站定位数据，请求、应答
#define CHAR_LOCATEDATAHIS_TOF_EXTEND       0x853b	// TOF历史定位数据，请求、应答
#define CHAR_LOCATEDATA_TOF_OPTIMIZE        0x753d  // TOF优化协议

// 2.tdoa
#define CHAR_LOCATEDATA_TDOA_EXTEND         0x863b	// 扩展TDOA实时定位数据，请求、应答
#define CHAR_LOCATEDATAHIS_TDOA_EXTEND      0x873b	// 扩展TDOA历史定位数据，请求、应答
#define CHAR_TDOA_READER_SYNC_TIME          0xa78d	// TDOA分站时间同步
#define CHAR_LOCATEDATA_TDOA                0x813b  // TDOA实时定位数据
#define CHAR_LOCATEDATA_TDOA_EXTEND_INS     0x901b  // 扩展TDOA实时定位数据，带惯导数据

// 3.pdoa
#define CHAR_LOCATEDATA_PDOA                0xa03b  // PDOA实时定位数据

// 4.light
#define CHAR_LIGHT_STATUS                   0x6a7c  // 红绿灯请求状态指令
#define CHAR_LIGHT_HEART                    0x5a1a  // 红绿灯心跳指令
#define CHAR_LIGHT_SETUP                    0x77a4  // 设置红绿灯参数信息

// 5.system
#define CHAR_CTRL_READER_CMD                0x804c	// 向分站发送控制指令，控制分站向上位机发送数据
#define CHAR_VIRTUAL_DATA_PUSH_CMD          0x699a	// 虚拟数据推送
#define CHAR_NET_CALI_TIME                  0x783b  // 网络设备校时，网络设备请求校时，上位机下发校时命令字
#define CHAR_CAN_CALI_TIME					0x784b	// CAN设备校时，CAN设备请求校时，上位机下发校时命令
#define CHAR_READER_HEART                   0x793a  // 无线通信基站心跳
// 6.third party
#define THIRD_PARTY_CHAR_LIGHT_REQ_STATE    0x95a0  // 第三方红绿灯请求状态指令，由红绿灯->采集
#define THIRD_PARTY_CHAR_LIGHT_HEART        0x95a1  // 第三方红绿灯心跳指令,由红绿灯->采集
#define THIRD_PARTY_CHAR_LIGHT_SETUP_STATE  0x95a2  // 第三方红绿灯设置状态指令，由采集->红绿灯


#endif
