#ifndef sync_time_helper_h
#define sync_time_helper_h

#include <fstream>
using namespace std;

namespace host_server{
	class sync_helper
	{
	public:
		//************************************
		// Description: 将char[5]解析成long long
		// Method:      parseTime
		// Returns:     long long 
		// Parameter:   char * time msg中携带的时间长度为5的char数组
		//************************************
		static long long parse_time(const char *time);

		//************************************
		// Description: 将基站号与天线号拼接成一个编码
		// Method:      parseId
		// Returns:     unsigned long long 拼接后的编码
		// Parameter:   unsigned int id 基站号
		// Parameter:   unsigned char antNum 天线号
		//************************************
		static unsigned long long parse_id(unsigned int id, unsigned char antNum);

        //************************************
        // Description: 从文件中分析数据
        // Method:      parseFromFstream
        // Returns:     unsigned long long
        // Parameter:   ifstream & f
        // Parameter:   int size
        //************************************
        static unsigned long long parse_from_fstream(ifstream &f, int size);

        //************************************
        // Description: 从文件中分析时间
        // Method:      parseTimeFromFstream
        // Returns:     unsigned long long
        // Parameter:   ifstream & f
        //************************************
        static unsigned long long parse_time_from_fstream(ifstream &f);
	};
}

#endif
